<?php
function fn_tagRelation() {
	global $configVal, $pluginURL, $entry;

	$data = setting::fetchConfigVal($configVal);
	$mother = $entry['id'];

	$context = Model_Context::getInstance();
	$blogid= $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$database_prefix = $context->getProperty('database.prefix');
	$defaultURL = $context->getProperty('uri.default');
	$currentURL = (isset( $_SERVER["HTTPS"]) && $_SERVER['HTTPS']=='on' ? 'https://':'http://').$_SERVER['HTTP_HOST'].($_SERVER['SERVER_PORT']=='80' || $_SERVER['SERVER_PORT']=='443' ? '' : ':'.$_SERVER['SERVER_PORT']).$_SERVER['REQUEST_URI'];
	$useSloganOnPost = $context->getProperty('blog.useSloganOnPost');

	// modified by jeongki, Pat-al
	if(is_null($data)) {
		$data['tagListEa'] = 9;
		$data['cutString'] = 50;
		$data['sortType'] = 1;
		$data['commentView'] = 1;
		$data['print_css'] = 1;
		$data['css'] = tagRelation_default_CSS();
		$data['rankIcon'] = 1;
		$data['tagComment'] = 1;
		$data['tagView'] = 0;
		$data['tagCount'] = 100;
		$data['wrappingTag'] = 'custom';
		$data['legend'] = tagRelation_default_legend();
		$data['tagHeader'] = tagRelation_default_tagHeader();
		$data['tagFooter'] = tagRelation_default_tagFooter();
	}

	$data['tagListEa'] = ($data['tagListEa'])?" LIMIT 0, {$data['tagListEa']} ":"";
	$tagIgnore = explode('|', $data['tagIgnore']);
	$tagIgnoreArray = array();
	$rowv = POD::queryAllWithDBCache("SELECT id FROM {$database_prefix}Tags WHERE name IN ('" . implode("', '", $tagIgnore) . "')");

	foreach($rowv as $rowresult) {
		$tagIgnoreArray[] = $rowresult[0];
	}

	$relationid = $mother;

	if($relationid) {
		$rowv = POD::queryAllWithDBCache("SELECT A.tag FROM {$database_prefix}TagRelations A, {$database_prefix}Tags B
			WHERE A.tag=B.id AND A.entry={$relationid} AND A.blogid = {$blogid} AND B.id NOT IN ('" . implode("', '", $tagIgnoreArray) . "')");

		foreach($rowv as $rowresult) {
			$tag_id .= $rowresult[0] . ',';
		}

		if(is_null($tag_id)) {
			$tag_id = '0';
		}
		else {
			$tag_id = substr($tag_id,0,(strlen($tag_id) - 1));
 		}

		// modified by jeongki, Pat-al
		switch($data['sortType']) {
			case 1 :
				$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, COUNT(B.id) AS cnt, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
					WHERE A.entry=B.id
					AND A.entry<>{$relationid}
					AND A.tag IN ({$tag_id})
					AND B.category >= 0
					AND B.id > 0
					AND B.blogid = {$blogid}
					AND B.visibility <> 0
					GROUP BY B.id
					ORDER BY cnt desc, RAND()
					{$data['tagListEa']}");
				break;
			case 2 :
				$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published as published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
					WHERE A.entry=B.id											
					AND A.entry<>{$relationid}
					AND A.tag IN ({$tag_id})
					AND B.category >= 0
					AND B.id > 0
					AND B.blogid = {$blogid}
					AND B.visibility <> 0
					GROUP BY B.id
					ORDER BY published desc
					{$data['tagListEa']}");
				break;
			case 3 :
				$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published as published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
					WHERE A.entry=B.id											
					AND A.entry<>{$relationid}
					AND A.tag IN ({$tag_id})
					AND B.category >= 0
					AND B.id > 0
					AND B.blogid = {$blogid}
					AND B.visibility <> 0
					GROUP BY B.id
					ORDER BY published asc
					{$data['tagListEa']}");
				break;
			case 4 :
				$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, B.published, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
					WHERE A.entry=B.id											
					AND A.entry<>{$relationid}
					AND A.tag IN ({$tag_id})
					AND B.category >= 0
					AND B.id > 0
					AND B.blogid = {$blogid}
					AND B.visibility <> 0
					GROUP BY B.id
					ORDER BY RAND()
					{$data['tagListEa']}");
				break;
			default :
				$row = POD::queryAllWithDBCache("SELECT B.id, B.title, B.slogan, COUNT(B.id) AS cnt, B.comments, B.visibility FROM {$database_prefix}TagRelations A, {$database_prefix}Entries B
					WHERE A.entry=B.id
					AND A.entry<>{$relationid}
					AND A.tag IN ({$tag_id})
					AND B.category >= 0
					AND B.id > 0
					AND B.blogid = {$blogid}
					AND B.visibility <> 0
					GROUP BY B.id
					ORDER BY cnt desc, RAND()
					{$data['tagListEa']}");
				break;
		}

		// 글 목록을 감싸는 글상자 머리글 HTML 넣기
 		if($data['wrappingTag']=='fieldset') {
			$tagrelation = '<fieldset class="tagrelation">';
			$tagrelation .= '<legend>' .$data['legend']. '</legend>';
		}
		else if($data['wrappingTag']=='div') {
			$tagrelation = '<div class="tagrelation">';
			$tagrelation .= '<span class="legend">' .$data['legend']. '</span>';
		}
		else {
			$tagrelation = $data['tagHeader'];
		}

		$tagrelation .= "<ul>";
		$i = 0;

		foreach($row as $result) {
			if ($result[5] == 0) continue;
			$i++;
			$r_id = $result[0];
	 	
			// modified by jeongki, Pat-al
 			// 어떤 보람말(태그)과 연결이 되어 있는지
			$r_row = POD::queryAllWithDBCache("SELECT A.tag, B.name, COUNT(tag) AS tagcount FROM 
				{$database_prefix}TagRelations A, {$database_prefix}Tags B
				WHERE (A.entry={$relationid} AND A.tag=B.id AND B.name >= ' ' AND A.blogid = {$blogid})
				OR (A.entry={$r_id} AND A.tag=B.id AND B.name >= ' ')
				GROUP BY A.tag
				HAVING tagcount > 1");

			// 보람말 고리 유무 및 보람말 고리 갯수 
			if ($data['tagView'] == 1) {
				$r_tagname = "[보람말 고리:";
				$j = 0;

				foreach($r_row as $r_result) {
					if ($j == $data['tagCount']) break;
					else if ($j) $r_tagname.='/';
					$j = ($data['tagCount'] == 100) ? 1 : $j;
					$modified_result = str_replace(' ', '%20', $r_result[1]);
					$r_tagname .= "<a href=\"{$blogURL}/tag/{$modified_result}\">{$r_result[1]}</a>";
					$j++;
				}
				$r_tagname .= ']';
			} else {
				$r_tagname = '';
			}

			$r_txt = ($result[1]);
			$tagLink = ($useSloganOnPost ? "entry/{$result[2]}" : $result[0]);
			if ($data['commentView'] == 1) {
				$repComment = ($result[4]) ? "<span class=\"c_cnt\">({$result[4]})</span>":"";
			} else 
				$repComment = "";

			$k = ($i-1)*72;
			$rankicon_path = $data['rankIconPath'] == 'http://' || empty($data['rankIconPath']) ? $pluginURL.'/icon/rank.png' : $data['rankIconPath'].'/rank.png';
			$rankicon = ($data['rankIcon'] == 1)?" style=\"background:url({$rankicon_path}) no-repeat 0px -{$k}px;padding-left:13px;\"":'';

			$tagrelation .= "<li {$rankicon}><a href=\"{$blogURL}/{$tagLink}\">" . htmlspecialchars(UTF8::lessenAsEm($r_txt, $data['cutString'], '…')) . "</a> {$repComment} {$r_tagname}</li>";
		}

		if (is_null($r_id)) {
			$tagrelation .= '<li>이 글의 보람말과 얽힌 글이 없습니다.</li>';
		}
		else {
			if ($data['tagComment'] == 1) {
				$tagrelation .= '<br/>* 보람말 고리란? 다른 글이 이 글에 쓰인 어떤 보람말과 얽혔는지 보여 주는 고리.';
			}
		}

		$tagrelation .= '</ul>';

		// 글 목록을 감싸는 글상자 꼬리글 HTML 넣기
		if($data['wrappingTag']=='fieldset') {
			$tagrelation .= '</fieldset>';
		}
		else if($data['wrappingTag']=='div') {
			$tagrelation .= '</div>';
		}
		else {
			$tagrelation .= $data['tagFooter'];
		}
 	}

	return $tagrelation; 
}


function tagRelation_onHead($target) {
	global $configVal;
	$data = setting::fetchConfigVal($configVal);	

	if(is_null($data))
		$target .= '<style type="text/css">'.CRLF.tagRelation_default_CSS().CRLF.'</style>';
	else if(isset($data['print_css']) && $data['print_css'] && !empty($data['css']))
		$target .= '<style type="text/css">'.CRLF.$data['css'].CRLF.'</style>';

	return $target;
}

function tagRelation_default_legend() {
	return '얽힌 글타래';
}

function tagRelation_default_tagHeader() {
	$html = '<fieldset class="tagrelation">
<legend>'.tagRelation_default_legend().'</legend>';
	return $html;
}

function tagRelation_default_tagFooter() {
	$html = '</fieldset>';
	return $html;
}

function tagRelation_default_CSS() {
	$css = '
fieldset.tagrelation {
	border:1px solid #888;
	padding:0 12px 12px 0;
	margin:10px 0 10px 0;
	overflow:hidden;
	font-size:12px;
}
fieldset.tagrelation legend {
	margin-left:12px;
	padding:2px 4px 2px 4px;
	font-size: 13px;
	font-weight:bold;
}
fieldset.tagrelation ul {
	padding:0 0 0 20px;
	margin:10px 0;
}
div.tagrelation {
	border:1px solid #888;
	padding:15px 15px 12px 15px;
	margin:10px 0 10px 0;
	overflow:hidden;
	font-size:12px;
}
div.tagrelation span.legend {
	margin:0 0 0 2px;
	padding:0;
	height:1em;
	line-height:1em;
	font-size:13px;	
	font-weight:bold;
}
div.tagrelation ul {
	padding:8px 0 0 3px;
	margin:8px 0;
	border-top:1px solid #aaa;
}

div.tagrelation a:link,
div.tagrelation a:visited,
fieldset.tagrelation a:link,
fieldset.tagrelation a:visited {
	color:#000;
	text-decoration:none;
	border:none;
}
.tagrelation ul li {
	list-style:none;
	clear:both;
}
'.CRLF;

	return $css;
}


function tagRelation_Config($plugin) {
	$manifest = '
	<config dataValHandler="tagRelationCfg">
		<window width="500" height="700" />
		<fieldset legend="표시 설정">
			<field title="무시할 보람말(|로 구분) : " name="tagIgnore" type="text" size="40" value="" />
			<field title="출력갯수 :" name="tagListEa" type="text" size="5" value="5" />
			<field title="제목 길이 제한 :" name="cutString" type="text" size="5" value="50" />
			<field title="정렬 방법 :" name="sortType" type="radio">
				<op value="1" checked="checked">관련 보람말 갯수 차례</op>
				<op value="2">최근 글 차례</op>
				<op value="3">예전 글 차례</op>
				<op value="4">랜덤</op>
			</field>
			<field title="덧글 수 :" name="commentView" type="radio">
				<op value="1" checked="checked">보임</op>
				<op value="2">안 보임</op>
			</field>
			<field title="순위 쪽그림 :" name="rankIcon" type="radio">
				<op value="1" checked="checked">보임</op>
				<op value="2">안 보임</op>
			</field>
		</fieldset>
		<fieldset legend="보람말 고리 관련 ">
			<field title="보람말 고리 설명 :" name="tagComment" type="radio">
				<op value="1">보이기</op>
				<op value="2" checked="checked">안 보이기</op>
			</field>
			<field title="보람말 목록 :" name="tagView" type="radio">
				<op value="1">보임</op>
				<op value="2" checked="checked">안 보임</op>
			</field>
			<field title="출력 갯수 :" name="tagCount" type="radio">
				<op value="1">1개</op>
				<op value="2">2개</op>
				<op value="3">3개</op>
				<op value="4">4개</op>
				<op value="5">5개</op>
				<op value="6">6개</op>
				<op value="7">7개</op>
				<op value="100" checked="checked">모두</op>
			</field>
		</fieldset>
		<fieldset legend="목록 제목">
			<field title=" " name="legend" type="text" size="40" value="'.tagRelation_default_legend().'" />
		</fieldset>
		<fieldset legend="목록을 감싸는 글상자 태그">
			<field title=" :" name="wrappingTag" type="radio">
				<op value="div"><![CDATA[&lt;DIV&gt;]]></op>
				<op value="fieldset"><![CDATA[&lt;FIELDSET&gt;]]></op>
				<op value="custom" checked="checked"><![CDATA[아래 HTML 머리글/꼬리글]]></op>
			</field>
		</fieldset>
		<fieldset legend="HTML 머리글">
			<field title="* 쓰고 있는 스킨의 skin.html 참고" name="tagHeader" cols="51" rows="3" type="textarea" titledirection="bk">
				<![CDATA['.tagRelation_default_tagHeader().']]>
			</field>
		</fieldset>
		<fieldset legend="HTML 꼬리글">
			<field title="* 쓰고 있는 스킨의 skin.html 참고" name="tagFooter" cols="51" rows="2" type="textarea" titledirection="bk">
				<![CDATA['.tagRelation_default_tagFooter().']]>
			</field>
		</fieldset>
		<fieldset legend="CSS 설정" name="css_set">
			<field title=" " name="print_on_head" type="checkbox">
				<op name="print_css" value="1" checked="checked"><![CDATA[CSS 넣기]]></op>
			</field>
			<field title=" " name="css" rows="7" cols="52" titledirection="bk" type="textarea">
			<![CDATA['.tagRelation_default_CSS().']]>
			</field>
		</fieldset>
		
		<fieldset legend="순위 쪽그림 파일 경로">
			<field title=" " name="rankIconPath" type="text" size="65" value="http://">
				<caption><![CDATA[※ 순위 쪽그림 파일을 다른 경로에서 불어오게 하여 전송량을 분산할 수 있습니다.]]></caption>
			</field>
		</fieldset>
	</config>'.CRLF;

	return $manifest;
}

function tagRelationCfg($data){
	$cfg = setting::fetchConfigVal($data);
	return true;
}
?>